import java.awt.*;
import java.awt.geom.*;
import java.awt.color.*;
import java.awt.image.*;
import java.io.*;

import com.sun.image.codec.jpeg.*;

public class LaplaceJpeg extends Frame {

  public static void main(String[] args)  throws Exception {
	if (args.length != 1) {
		System.out.println("Usage: java GrayJpeg " +
			"input_image_filename");
		System.exit(-1);
	}
    Frame f = new LaplaceJpeg(args[0]);
    f.setSize(mImage.getWidth(), mImage.getHeight());
    f.setLocation(200, 200);
    f.setVisible(true);
  }
  
  private static BufferedImage mImage;
  
  public LaplaceJpeg(String filename)
      throws IOException, ImageFormatException {
    // Load the specified JPEG file.
    InputStream in = new FileInputStream(filename);
    JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);
    mImage = decoder.decodeAsBufferedImage();
    in.close();
  }
  
  public void paint(Graphics g) {
    Graphics2D g2 = (Graphics2D)g;
    BufferedImageOp op =
      new ConvolveOp(new Kernel(3, 3, new float[]{ 0, -1, 0, -1, 4, -1, 0, -1, 0 }));
    g2.drawImage(mImage, op, 0, 0);
  }
}
